dialog slc2 {
  title "Server Links Checker v. 2.2"
  size -1 -1 205 136
  option dbu
  list 1, 4 6 113 113, size vsbar
  button "Refresh", 2, 120 120 35 12, flat
  button "Close", 4, 161 120 37 12, flat ok cancel
  radio "Default (6667)", 5, 130 67 50 10
  radio "Selected", 6, 130 80 35 10
  box "Ping socket port", 7, 121 55 78 41
  edit "", 8, 167 79 28 10, read
  check "New server window", 10, 130 31 62 11
  button "Connect!", 9, 141 16 35 12, flat
  edit "", 11, 4 121 113 10, read autohs
  button "Update mIRC servers", 12, 121 101 77 12, flat
  box "", 3, 121 4 78 45
}



alias _o { return $eval([,0) $1- $eval(],0) }
on *:unload:{
  unset %slc*
}
on *:load:{
  set %slc.alsopings 1
  set %slc.set.port 5
  set %slc.port 6667
  echo -ts Server Links Checker 2.2 is now loaded.
  echo -ts To use it, right click in channel, or status window and select Server Link Checker
}
on *:dialog:slc2:init:0:{
  unset %slc.server*
  unset %slc.delay
  set %slc.alsopings 1
  did -c $dname %slc.set.port
  if (%slc.set.port == 6) { did -n slc2 8 | did -a slc2 8 %slc.port }
}
on *:dialog:slc2:sclick:9:{
  if ($did(10).state == 1) {
    if (!$did(1).sel) { var %r = $input(You have to select the server first ;],o) }
    else { server -m $gettok($did(1).seltext,1,32) %slc.port }
  }
  else {
    if (!$did(1).sel) { var %r = $input(You have to select the server first ;],o) }
    else { server $gettok($did(1).seltext,1,32) %slc.port }
  }
}
on *:dialog:slc2:sclick:5:{
  did -m $dname 8
  set %slc.set.port 5
  set %slc.port 6667
}
on *:dialog:slc2:edit:8:{
  set %slc.port $did(8).text
}
on *:dialog:slc2:sclick:6:{
  did -n $dname 8
  set %slc.set.port 6
}

alias oOo {
  sockmark slc. $+ $1 $ticks
}

alias oooo {
  sockopen slc. $+ $1 $1 %slc.port

}
raw 364:*:{
  if (* !isin $2) {
    if (%slc.alsopings) {
      if (!%slc.delay) { set %slc.delay 1 }
      .timer 1 %slc.delay oooo $2
      .timer 1 %slc.delay oOo $2
      inc %slc.delay 1
    }
  }
  set %slc.server. $+ $2 $2 -p 6667 -g $iif($network,$network,Unknown)
  if ($dialog(slc2)) { did -a slc2 1 $2 }
  set %slc.info. $+ %slc.count $5-
  inc %slc.count

}
on :dialog:slc2:close:*:{
  sockclose slc.*
  .timerslc* off
}

raw 365:*:{
  if (%slc.halt == 1) {
    set %slc.count 1
    set %slc.halt 0
    set %slc.total $var(%slc.info*,0)
    set %slc.network $network
    if ($dialog(slc2)) { dialog -t slc2 SLC v2.1 $_o(%slc.total servers on $network) }
    halt
  }
}
on *:sockopen:slc.*:{
  if ($sockerr) && ($dialog(slc2)) {
    var %se = $var(slc.sock* $+ $gettok($sock($sockname).name,2-,46),1).value
    did -o slc2 1 $didwm(slc2,1,$gettok($sock($sockname).name,2-,46)) $gettok($sock($sockname).name,2-,46) - $_o( n/a )
    return
  }
  if ($dialog(slc2)) {
    var %se = $var(slc.sock* $+ $gettok($sock($sockname).name,2-,46),1).value
    did -o slc2 1 $didwm(slc2,1,$gettok($sock($sockname).name,2-,46)) $gettok($sock($sockname).name,2-,46) - $_o($calc($ticks - $sock($sockname).mark) $+ ms)
    sockclose $sockname
  }
}
on *:dialog:slc2:sclick:2:{
  if ($server) {
    var %nt = $Input(Should Server Links Checker refresh also ping times?,y)
    if (%nt) { raw -q links | unset %slc.delay | set %slc.halt 1 | unset %slc.info* | unset %slc.sock* | sockclose slc* | .timerslc* off | set %slc.alsopings 1 | did -r slc2 1 }
    else { raw -q links | unset %slc.delay | set %slc.halt 1 | unset %slc.info* | unset %slc.sock* | sockclose slc* | .timerslc* off | set %slc.alsopings 0 | did -r slc2 1 }
  }

}
menu status,channel {
  Server Links Checker:$iif($dialog(slc2),return) | set %slc.count 1 | unset %slc.sock.* | unset %slc.info* | sockclose slc* | dialog -m slc2 slc2 | raw -q links | set %slc.halt 1
}
on *:dialog:slc2:sclick:12:{
  if (%slc.halt == 1) { var %t = $input(Servers list is incomplete $+ $chr(44) please wait, o) | return }
  var %t = $var(slc.server*,0), %y = 1
  while (%y <= %t) {
    .server -sa $var(slc.server*,%y).value
    inc %y
  }
  did -ra $dname 11  mIRC servers list is now updated !
}
on *:dialog:slc2:sclick:1:{
  did -ra slc2 11 $var(slc.info. $+ $did(1).sel,1).value
}
